#ifndef FRONTA_H
  #define FRONTA_H

  #include <iostream.h>

  template<class T> class CFronta {
	private : 
		T *m_Pole;
		int m_Velikost;	// maximalni velikost (delka) fronty
		int m_Zacatek, m_Konec;	// kde je zacatek a konec fronty
		int m_Pocet;	// pocet prvku prave se nachazejicich ve fronte
			
	public :
		CFronta(int _Velikost);
		~CFronta();

		bool Vloz(const T& _Vklad);
		bool Vyjmi(T& _Vyber);
		
		bool JePrazdna() { return ((0 == m_Pocet) ? true : false); }
		bool JePlna() { return ((m_Pocet == m_Velikost) ? true : false); }

		void Vypis();
  };
	
  template<class T> CFronta<T>::CFronta(int _Velikost)
  {
	  m_Velikost = -1;
	  m_Pocet = 0;
	  m_Zacatek = 0;
	  m_Konec = -1;	// abychom v metode Vloz dostali spravny konec po prvnim vlozeni
	  
	  m_Pole = new T[_Velikost];

	  if(m_Pole)
	  {
		  // pokud se podarilo nastavime velikost
		  m_Velikost = _Velikost;
	  }
  }

  template<class T> CFronta<T>::~CFronta()
  {
	  if(m_Pole)
	  {
		  delete[] m_Pole;
		  m_Pole = NULL;
		  m_Velikost = 0;
	  }
  }

  template<class T> bool CFronta<T>::Vloz(const T& _Vklad)
  {
	  bool bNavrat = false;

	  if(m_Pole)
	  {
		  if(!JePlna())
		  {
			  if(m_Konec == (m_Velikost - 1))
			  {
				  // pokud konec dosahne konce pole, pak koncime na prvnim prvku pole
				  m_Konec = 0;
			  }
			  else
			  {
				  m_Konec++;
			  }

			  m_Pole[m_Konec] = _Vklad;
			  m_Pocet++;	// pribyl prvek

			  bNavrat = true;
		  }
	  }

	  return bNavrat;
  }

  template<class T> bool CFronta<T>::Vyjmi(T& _Vyber)
  {
	  bool bNavrat = false;

	  if(m_Pole)
	  {
		  if(!JePrazdna())
		  {
			  _Vyber = m_Pole[m_Zacatek];
			  
			  if(m_Zacatek == (m_Velikost - 1))
			  {
				  // pokud zacatek dosahne konce pole, pak zaciname zase na prvnim prvku
				  m_Zacatek = 0;
			  }
			  else
			  {
				  // posun na novy zacatek
				  m_Zacatek++;
			  }

			  m_Pocet--;	// ubyl prvek

			  bNavrat = true;
		  }
	  }

	  return bNavrat;
  }

  template <class T> void CFronta<T>::Vypis()
  {
	  if(m_Pole)
	  {
		  if(!JePrazdna())
		  {
			  cout << "Obsahuje " << m_Pocet << " objektu (volnych " << m_Velikost - (m_Pocet) << ")" << endl;
			  for(int i = 0; i < m_Velikost; i++)
			  {
				  cout << m_Pole[i] << endl;
			  }
		  }
		  else
		  {
			  cout << "Fronta je prazdna" << endl;
		  }
	  }
  }

#endif
